<!----------------------------------------------------------------------------------------------------------------------
  -- Login Widget
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="login">
        <BDropdown v-if="account" id="login-dropdown" right>
            <template #button-content>
                <BAvatar :src="account.avatar" size="1.5rem" />
            </template>
            <BDropdownHeader>{{ account.email }}</BDropdownHeader>
            <!--            <b-dropdown-item disabled>-->
            <!--                <fa icon="cog"></fa>-->
            <!--                Settings-->
            <!--            </b-dropdown-item>-->
            <BDropdownDivider />
            <BDropdownItem @click="logout()">
                <Fa icon="sign-out" />
                Log Out
            </BDropdownItem>
        </BDropdown>
        <BButton v-else variant="primary" href="/auth/gitlab">
            <Fa :icon="[ 'fab', 'gitlab' ]" />
            Login
        </BButton>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    #login-dropdown {
        & > .btn {
            padding-top: 0.25rem;
            padding-bottom: 0.25rem;
            height: 38px;
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { useObservable } from '../../lib/composables/rxjs.js';

    // Managers
    import authMan from '../../lib/managers/auth.js';

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const account = useObservable(authMan.account$);

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function logout() : void
    {
        authMan.logout();
    }
</script>

<!--------------------------------------------------------------------------------------------------------------------->
